﻿

//Parameters:
// scanType      : "R"-Regular, "Q"-Quick
// listID        : destination list ID. GUID without brackets
// rootFolder    : destination folder relative url. Send empty string to scan to the library root folder
// refreshPage   : true/false. Refresh page after upload
// showProperties: true/false. Show document properties after upload


function wsSPScanSDK(scanType, listId, rootFolder, refreshPage, showProperties) {
    this.scanType = scanType;
    this.listId = String(listId);
    this.rootFolder = rootFolder;
    this.refreshPage = refreshPage;
    this.showProperties = showProperties;
}

wsSPScanSDK.prototype = {
    scan: function () {
        var that = this;
        SP.SOD.executeFunc('sp.js', 'SP.ClientContext', function () {
            var options = SP.UI.$create_DialogOptions();
            var webURL = window.location.protocol + "//" + window.location.host + _spPageContextInfo.webServerRelativeUrl;
            if (!endsWith(webURL, "/"))
                webURL = webURL + "/";



            options.url = webURL + "_layouts/15/WebsioScannerPlugin2013/scan.aspx?rootfolder=" + that.rootFolder + "&ListId=" + that.listId + "&type=" + that.scanType;
            options.width = 500;
            options.height = 150;
            options.dialogReturnValueCallback = Function.createDelegate(null, CloseCallback);
            SP.UI.ModalDialog.showModalDialog(options);

            function CloseCallback(result, retVal) {
                if (result == SP.UI.DialogResult.OK) {
                    if (retVal == '0') {
                        if (that.refreshPage) {
                            _RefreshPage(SP.UI.DialogResult.OK);
                        }
                    }
                    else {
                        if (that.showProperties) {
                            var ev = null;
                            if (typeof event != 'undefined') {
                                ev = event;
                            }

                            NewOrEditV4Core(ev, webURL + "/_layouts/15/listform.aspx?PageType=6&ListId={" + that.listId + "}&ID=" + retVal, true);
                        }
                        else {
                            if (that.refreshPage) {
                                _RefreshPage(SP.UI.DialogResult.OK);
                            }

                        }
                    }
                }
            }


        });

    }
}


function endsWith(str, suffix) {
    return str.indexOf(suffix, str.length - suffix.length) !== -1;
}

