﻿var wsExternalSPScanSDK = function (elm, scanType, siteURL, folderURL, fileName, callbackfunc) {
    this.scanType = scanType;
    this.siteURL = siteURL;
    this.folderURL = folderURL;
    this.fileName = fileName;
    this.callbackfunc = callbackfunc;
    this.properties = "";
    this.elm = elm;
    this.controlImage = null;
}

wsExternalSPScanSDK.prototype = {

    addProperty: function (propName, propType, propValue) {
        var propPrefix = "pr_";
        switch (propType) {
            case "string":
                propPrefix = propPrefix + "s_";
                break;
            case "datetime":
                propPrefix = propPrefix + "d_";
                break;
            case "lookup":
                propPrefix = propPrefix + "l_";
                break;
            case "number":
                propPrefix = propPrefix + "n_";
                break;
            case "url":
                propPrefix = propPrefix + "u_";
                break;
            default:
                alert("wsExternalSPScanSDK.addProperty - Unknown property type");
                return;
        }

        this.properties = this.properties + "&";

        this.properties = this.properties + propPrefix + propName + "=" + propValue;


    },

    scan: function () {
        this.controlImage = $('<img/>');
        $(this.controlImage).css("margin-left", "-100px");
        $(this.elm).append(this.controlImage);

        var imgsrc = encodeURI("http://localhost:8080/scan.png?type=" + this.scanType + "&site=" + this.siteURL + "&folder=" + this.folderURL + "&filename=" + this.fileName + this.properties + "&csh=" + new Date().getTime());

        this.controlImage.attr('src', imgsrc);

        setTimeout(this.internalCheckStartResult.bind(this), 5000);
    },

    internalCheckStartResult: function () {
        var w = this.controlImage.width();
        this.controlImage.remove();
        this.controlImage = null;
        if (w != 5) {
            alert("Cannot connect to the eDocStation");
        }
        else
            this.internalWaitForDocResult();
    },

    internalWaitForDocResult: function () {
        this.controlImage = $('<img/>');
        $(this.controlImage).css("margin-left", "-100px");
        $(this.elm).append(this.controlImage);

        var imgsrc = "http://localhost:8080/result.png?csh=" + new Date().getTime();
        this.controlImage.attr('src', imgsrc);

        setTimeout(this.internalCheckDocResult.bind(this), 2000);
    },

    internalCheckDocResult: function () {

        var w = this.controlImage.width();
        this.controlImage.remove();
        this.controlImage = null;
        if (w != 10) {
            if (this.callbackfunc != null) {
                this.callbackfunc();
            }
        }
        else
            setTimeout(this.internalWaitForDocResult.bind(this), 2000);

    }

}